\ To test the ANS Forth Memory-Allocation word set

\ Copyright (C) Gerry Jackson 2006, 2007, 2009

\ This program is free software; you can redistribute it and/or
\ modify it any way.

\ This program is distributed in the hope that it will be useful,
\ but WITHOUT ANY WARRANTY; without even the implied warranty of
\ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

\ The tests are not claimed to be comprehensive or correct 

\ ------------------------------------------------------------------------------
\ Version 0.4 9 March 2009 Aligned test improved and data space pointer tested
\         0.3 6 March 2009 { and } replaced with T{ and }T
\         0.2 20 April 2007  ANS Forth words changed to upper case
\         0.1 October 2006 First version released

\ ------------------------------------------------------------------------------
\ The tests are based on John Hayes test program for the core word set
\ and requires those files to have been loaded

\ Words tested in this file are:
\     ALLOCATE FREE RESIZE
\     
\ ------------------------------------------------------------------------------
\ Assumptions and dependencies:
\     - that 'addr -1 ALLOCATE' and 'addr -1 RESIZE' will return an error
\     - tester.fr has been loaded prior to this file
\     - testing FREE failing is not done as it is likely to crash the
\       system
\ ------------------------------------------------------------------------------

TESTING Memory-Allocation word set

DECIMAL

0 CONSTANT <false>

\ ------------------------------------------------------------------------------

TESTING ALLOCATE FREE RESIZE

VARIABLE addr
VARIABLE datsp

HERE datsp !
T{ 100 ALLOCATE SWAP addr ! -> 0 }T
T{ addr @ ALIGNED -> addr @ }T   \ Test address is aligned
T{ HERE -> datsp @ }T            \ Check data space pointer is unchanged
T{ addr @ FREE -> 0 }T

T{ 99 ALLOCATE SWAP addr ! -> 0 }T
T{ addr @ ALIGNED -> addr @ }T
T{ addr @ FREE -> 0 }T

T{ 50 ALLOCATE SWAP addr ! -> 0 }T

: writemem 0 DO I 1+ OVER C! 1+ LOOP DROP ;	( ad n -- )

: checkmem  ( ad n --- )
   0
   DO
      DUP C@ SWAP >R
      T{ -> R> I 1+ SWAP >R }T  \ Luckily tester checks can be compiled
      R> 1+
   LOOP
   DROP
;

addr @ 50 writemem addr @ 50 checkmem

T{ addr @ 28 RESIZE SWAP addr ! -> 0 }T

addr @ 28 checkmem

T{ addr @ 200 RESIZE SWAP addr ! -> 0 }T

T{ addr @ 28 checkmem

\ ------------------------------------------------------------------------------

TESTING failure of RESIZE and ALLOCATE (unlikely to be enough memory)

T{ addr @ -1 RESIZE 0= -> addr @ <false> }T

T{ addr @ FREE -> 0 }T

T{ -1 ALLOCATE SWAP DROP 0= -> <false> }T		\ Memory allocate failed

\ ------------------------------------------------------------------------------

CR .( End of Memory-Allocation word tests) CR
